package com.persagy.gis.json

import com.fasterxml.jackson.core.JsonParser
import com.fasterxml.jackson.core.JsonToken
import com.fasterxml.jackson.databind.DeserializationContext
import com.fasterxml.jackson.databind.JsonDeserializer
import com.persagy.gis.entity.SGisPosition

/**
 * 自定义 SGisPosition 3 维数组对象反序列化器
 *
 * @author  庞利祥 <sybotan@126.com>
 */
class SGisPositionArray3Deserializer : JsonDeserializer<ArrayList<ArrayList<ArrayList<SGisPosition>>>>() {
    /** SGisPosition 2 维对象数组序列化器 */
    private val deserializer = SGisPositionArray2Deserializer()

    /**
     *
     *
     * @return Deserialized value
     */
    override fun deserialize(parser: JsonParser, ctxt: DeserializationContext): ArrayList<ArrayList<ArrayList<SGisPosition>>> {
        // 存储读取的元素值
        val valueList = ArrayList<ArrayList<ArrayList<SGisPosition>>>()

        var token = parser.nextToken()

        // 依次读取数值型对象
        do {
            val pos = deserializer.deserialize(parser, ctxt)
            valueList.add(pos)
            token = parser.nextToken()
        } while ((token != JsonToken.END_ARRAY))

        // 根据读取的数值创建并返回 SGisPosition对象
        return valueList
    }
}