package com.persagy.gis.json

import com.fasterxml.jackson.core.JsonParser
import com.fasterxml.jackson.core.JsonToken
import com.fasterxml.jackson.databind.DeserializationContext
import com.fasterxml.jackson.databind.JsonDeserializer
import com.persagy.gis.entity.SGisPosition

/**
 * 自定义 SGisPosition 数组对象反序列化器
 *
 * @author  庞利祥 <sybotan@126.com>
 */
class SGisPositionArrayDeserializer : JsonDeserializer<ArrayList<SGisPosition>>()  {
    /** SGisPosition 对象序列化器 */
    private val deserializer = SGisPositionDeserializer()

    /**
     *
     *
     * @return Deserialized value
     */
    override fun deserialize(parser: JsonParser, ctxt: DeserializationContext): ArrayList<SGisPosition> {
        // 存储读取的元素值
        val valueList = ArrayList<SGisPosition>()

        var token = parser.nextToken()

        // 依次读取数值型对象
        do {
            val pos = deserializer.deserialize(parser, ctxt)

            if (pos != null) {
                valueList.add(pos)
            }

            token = parser.nextToken()
        } while ((token != JsonToken.END_ARRAY))

        // 根据读取的数值创建并返回 SGisPosition对象
        return valueList
    }
}